<template>
    <div class="container-game">
      <div>
        <h2>Gioca a scacchi contro la community di Twitter</h2>
        <p>Gioca contro un avversario random oppure condividi la partita per giocare contro gli utenti di Twitter</p>
      </div>
      <div class="board">
        <newboardComponent @click-share="viewBoard($event)"/>
      </div>
      <div class="box">
        <div v-if="shareable">
          <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" @click="shareGame()">Condividi</b-button>
        </div>
        <div v-if="opponentTurn">
          <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" @click="opponentMove()">Prendi i Retweet</b-button>
        </div>
        <div v-if="aiTurn">
          <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" @click="aiMove()">Random</b-button>
        </div>
      </div>
    </div>
</template>

<script>
import {chessboard} from 'vue-chessboard'
import 'vue-chessboard/dist/vue-chessboard.css'
import newboardComponent from '@/components/newboardComponent.vue'

export default {
  extends: chessboard,
  components: {
    newboardComponent
  },
  data() {
    return {
      board: '',
      opponentTurn: false,
      shareable: false,
      aiTurn: false,
    }
  },
  mounted() {
  },
  methods: {
    shareGame: async function() {
      await this.$root.$emit("shareGameButton", (this.board))
      this.shareable = false
      this.opponentTurn = true
      this.aiTurn = true
    },
    opponentMove: async function() {
      this.shareable = false
      this.opponentTurn = false
      this.aiTurn = false
      await this.$root.$emit("opponentMove")
    },
    viewBoard(event) {
      console.log(event)
      this.board = event;
      this.shareable = true;
      this.opponentTurn = false
      this.aiTurn = true
    },
    aiMove: function() {
      this.shareable = false
      this.opponentTurn = false
      this.aiTurn = false
      this.$root.$emit("cpuMove")
    }
  }
};
</script>

<style scoped>
.container-game {
  margin: 2rem;
}
.box {
  display: flex;
  align-items: flex-start;
  justify-content: center;
}
.margin {
  margin-left: 2rem;
  display: grid;
  grid-gap: 1rem;
}
.margin button {
  width: 100%;
}
.box button {
  margin-right: 1rem;
}
::v-deep .cg-board-wrap {
  margin: 0 auto;
}
</style>
